Index: CKEditor/branches/versions/3.5.x/_source/plugins/link/dialogs/link.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/link/dialogs/link.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/link/dialogs/link.js	(revision 6050)
@@ -244,7 +244,5 @@
 			var item = elements.getItem( i );
 			if ( item.getAttribute( '_cke_realelement' ) && item.getAttribute( '_cke_real_element_type' ) == 'anchor' )
-			{
 				anchors.push( editor.restoreRealElement( item ) );
-			}
 		}
 
@@ -364,6 +362,9 @@
 	}
 
+	var commonLang = editor.lang.common,
+		linkLang = editor.lang.link;
+
 	return {
-		title : editor.lang.link.title,
+		title : linkLang.title,
 		minWidth : 350,
 		minHeight : 230,
@@ -371,6 +372,6 @@
 			{
 				id : 'info',
-				label : editor.lang.link.info,
-				title : editor.lang.link.info,
+				label : linkLang.info,
+				title : linkLang.info,
 				elements :
 				[
@@ -378,11 +379,11 @@
 						id : 'linkType',
 						type : 'select',
-						label : editor.lang.link.type,
+						label : linkLang.type,
 						'default' : 'url',
 						items :
 						[
-							[ editor.lang.link.toUrl, 'url' ],
-							[ editor.lang.link.toAnchor, 'anchor' ],
-							[ editor.lang.link.toEmail, 'email' ]
+							[ linkLang.toUrl, 'url' ],
+							[ linkLang.toAnchor, 'anchor' ],
+							[ linkLang.toEmail, 'email' ]
 						],
 						onChange : linkTypeChanged,
@@ -410,5 +411,5 @@
 										id : 'protocol',
 										type : 'select',
-										label : editor.lang.common.protocol,
+										label : commonLang.protocol,
 										'default' : 'http://',
 										items :
@@ -419,5 +420,5 @@
 											[ 'ftp://\u200E', 'ftp://' ],
 											[ 'news://\u200E', 'news://' ],
-											[ editor.lang.link.other , '' ]
+											[ linkLang.other , '' ]
 										],
 										setup : function( data )
@@ -437,5 +438,5 @@
 										type : 'text',
 										id : 'url',
-										label : editor.lang.common.url,
+										label : commonLang.url,
 										required: true,
 										onLoad : function ()
@@ -478,5 +479,5 @@
 												return true;
 
-											var func = CKEDITOR.dialog.validate.notEmpty( editor.lang.link.noUrl );
+											var func = CKEDITOR.dialog.validate.notEmpty( linkLang.noUrl );
 											return func.apply( this );
 										},
@@ -514,5 +515,5 @@
 								hidden : 'true',
 								filebrowser : 'info:url',
-								label : editor.lang.common.browseServer
+								label : commonLang.browseServer
 							}
 						]
@@ -529,5 +530,5 @@
 								type : 'fieldset',
 								id : 'selectAnchorText',
-								label : editor.lang.link.selectAnchor,
+								label : linkLang.selectAnchor,
 								setup : function( data )
 								{
@@ -548,5 +549,5 @@
 												id : 'anchorName',
 												'default' : '',
-												label : editor.lang.link.anchorName,
+												label : linkLang.anchorName,
 												style : 'width: 100%;',
 												items :
@@ -583,5 +584,5 @@
 												id : 'anchorId',
 												'default' : '',
-												label : editor.lang.link.anchorId,
+												label : linkLang.anchorId,
 												style : 'width: 100%;',
 												items :
@@ -625,5 +626,5 @@
 								id : 'noAnchors',
 								style : 'text-align: center;',
-								html : '<div role="label" tabIndex="-1">' + CKEDITOR.tools.htmlEncode( editor.lang.link.noAnchors ) + '</div>',
+								html : '<div role="label" tabIndex="-1">' + CKEDITOR.tools.htmlEncode( linkLang.noAnchors ) + '</div>',
 								// Focus the first element defined in above html.
 								focus : true,
@@ -652,5 +653,5 @@
 								type : 'text',
 								id : 'emailAddress',
-								label : editor.lang.link.emailAddress,
+								label : linkLang.emailAddress,
 								required : true,
 								validate : function()
@@ -662,5 +663,5 @@
 										return true;
 
-									var func = CKEDITOR.dialog.validate.notEmpty( editor.lang.link.noEmail );
+									var func = CKEDITOR.dialog.validate.notEmpty( linkLang.noEmail );
 									return func.apply( this );
 								},
@@ -685,5 +686,5 @@
 								type : 'text',
 								id : 'emailSubject',
-								label : editor.lang.link.emailSubject,
+								label : linkLang.emailSubject,
 								setup : function( data )
 								{
@@ -702,5 +703,5 @@
 								type : 'textarea',
 								id : 'emailBody',
-								label : editor.lang.link.emailBody,
+								label : linkLang.emailBody,
 								rows : 3,
 								'default' : '',
@@ -729,6 +730,6 @@
 			{
 				id : 'target',
-				label : editor.lang.link.target,
-				title : editor.lang.link.target,
+				label : linkLang.target,
+				title : linkLang.target,
 				elements :
 				[
@@ -741,16 +742,16 @@
 								type : 'select',
 								id : 'linkTargetType',
-								label : editor.lang.common.target,
+								label : commonLang.target,
 								'default' : 'notSet',
 								style : 'width : 100%;',
 								'items' :
 								[
-									[ editor.lang.common.notSet, 'notSet' ],
-									[ editor.lang.link.targetFrame, 'frame' ],
-									[ editor.lang.link.targetPopup, 'popup' ],
-									[ editor.lang.common.targetNew, '_blank' ],
-									[ editor.lang.common.targetTop, '_top' ],
-									[ editor.lang.common.targetSelf, '_self' ],
-									[ editor.lang.common.targetParent, '_parent' ]
+									[ commonLang.notSet, 'notSet' ],
+									[ linkLang.targetFrame, 'frame' ],
+									[ linkLang.targetPopup, 'popup' ],
+									[ commonLang.targetNew, '_blank' ],
+									[ commonLang.targetTop, '_top' ],
+									[ commonLang.targetSelf, '_self' ],
+									[ commonLang.targetParent, '_parent' ]
 								],
 								onChange : targetChanged,
@@ -759,4 +760,5 @@
 									if ( data.target )
 										this.setValue( data.target.type );
+									targetChanged.call( this );
 								},
 								commit : function( data )
@@ -771,5 +773,5 @@
 								type : 'text',
 								id : 'linkTargetName',
-								label : editor.lang.link.targetFrameName,
+								label : linkLang.targetFrameName,
 								'default' : '',
 								setup : function( data )
@@ -798,5 +800,5 @@
 							{
 								type : 'fieldset',
-								label : editor.lang.link.popupFeatures,
+								label : linkLang.popupFeatures,
 								children :
 								[
@@ -808,5 +810,5 @@
 												type : 'checkbox',
 												id : 'resizable',
-												label : editor.lang.link.popupResizable,
+												label : linkLang.popupResizable,
 												setup : setupPopupParams,
 												commit : commitPopupParams
@@ -815,5 +817,5 @@
 												type : 'checkbox',
 												id : 'status',
-												label : editor.lang.link.popupStatusBar,
+												label : linkLang.popupStatusBar,
 												setup : setupPopupParams,
 												commit : commitPopupParams
@@ -829,5 +831,5 @@
 												type : 'checkbox',
 												id : 'location',
-												label : editor.lang.link.popupLocationBar,
+												label : linkLang.popupLocationBar,
 												setup : setupPopupParams,
 												commit : commitPopupParams
@@ -837,5 +839,5 @@
 												type : 'checkbox',
 												id : 'toolbar',
-												label : editor.lang.link.popupToolbar,
+												label : linkLang.popupToolbar,
 												setup : setupPopupParams,
 												commit : commitPopupParams
@@ -851,5 +853,5 @@
 												type : 'checkbox',
 												id : 'menubar',
-												label : editor.lang.link.popupMenuBar,
+												label : linkLang.popupMenuBar,
 												setup : setupPopupParams,
 												commit : commitPopupParams
@@ -859,5 +861,5 @@
 												type : 'checkbox',
 												id : 'fullscreen',
-												label : editor.lang.link.popupFullScreen,
+												label : linkLang.popupFullScreen,
 												setup : setupPopupParams,
 												commit : commitPopupParams
@@ -873,5 +875,5 @@
 												type : 'checkbox',
 												id : 'scrollbars',
-												label : editor.lang.link.popupScrollBars,
+												label : linkLang.popupScrollBars,
 												setup : setupPopupParams,
 												commit : commitPopupParams
@@ -881,5 +883,5 @@
 												type : 'checkbox',
 												id : 'dependent',
-												label : editor.lang.link.popupDependent,
+												label : linkLang.popupDependent,
 												setup : setupPopupParams,
 												commit : commitPopupParams
@@ -896,5 +898,5 @@
 												widths : [ '50%', '50%' ],
 												labelLayout : 'horizontal',
-												label : editor.lang.link.popupWidth,
+												label : linkLang.popupWidth,
 												id : 'width',
 												setup : setupPopupParams,
@@ -906,5 +908,5 @@
 												labelLayout : 'horizontal',
 												widths : [ '50%', '50%' ],
-												label : editor.lang.link.popupLeft,
+												label : linkLang.popupLeft,
 												id : 'left',
 												setup : setupPopupParams,
@@ -922,5 +924,5 @@
 												labelLayout : 'horizontal',
 												widths : [ '50%', '50%' ],
-												label : editor.lang.link.popupHeight,
+												label : linkLang.popupHeight,
 												id : 'height',
 												setup : setupPopupParams,
@@ -931,5 +933,5 @@
 												type :  'text',
 												labelLayout : 'horizontal',
-												label : editor.lang.link.popupTop,
+												label : linkLang.popupTop,
 												widths : [ '50%', '50%' ],
 												id : 'top',
@@ -948,6 +950,6 @@
 			{
 				id : 'upload',
-				label : editor.lang.link.upload,
-				title : editor.lang.link.upload,
+				label : linkLang.upload,
+				title : linkLang.upload,
 				hidden : true,
 				filebrowser : 'uploadButton',
@@ -957,5 +959,5 @@
 						type : 'file',
 						id : 'upload',
-						label : editor.lang.common.upload,
+						label : commonLang.upload,
 						style: 'height:40px',
 						size : 29
@@ -964,5 +966,5 @@
 						type : 'fileButton',
 						id : 'uploadButton',
-						label : editor.lang.common.uploadSubmit,
+						label : commonLang.uploadSubmit,
 						filebrowser : 'info:url',
 						'for' : [ 'upload', 'upload' ]
@@ -972,6 +974,6 @@
 			{
 				id : 'advanced',
-				label : editor.lang.link.advanced,
-				title : editor.lang.link.advanced,
+				label : linkLang.advanced,
+				title : linkLang.advanced,
 				elements :
 				[
@@ -989,5 +991,5 @@
 										type : 'text',
 										id : 'advId',
-										label : editor.lang.link.id,
+										label : linkLang.id,
 										setup : setupAdvParams,
 										commit : commitAdvParams
@@ -996,12 +998,12 @@
 										type : 'select',
 										id : 'advLangDir',
-										label : editor.lang.link.langDir,
+										label : linkLang.langDir,
 										'default' : '',
 										style : 'width:110px',
 										items :
 										[
-											[ editor.lang.common.notSet, '' ],
-											[ editor.lang.link.langDirLTR, 'ltr' ],
-											[ editor.lang.link.langDirRTL, 'rtl' ]
+											[ commonLang.notSet, '' ],
+											[ linkLang.langDirLTR, 'ltr' ],
+											[ linkLang.langDirRTL, 'rtl' ]
 										],
 										setup : setupAdvParams,
@@ -1012,5 +1014,5 @@
 										id : 'advAccessKey',
 										width : '80px',
-										label : editor.lang.link.acccessKey,
+										label : linkLang.acccessKey,
 										maxLength : 1,
 										setup : setupAdvParams,
@@ -1027,5 +1029,5 @@
 									{
 										type : 'text',
-										label : editor.lang.link.name,
+										label : linkLang.name,
 										id : 'advName',
 										setup : setupAdvParams,
@@ -1035,5 +1037,5 @@
 									{
 										type : 'text',
-										label : editor.lang.link.langCode,
+										label : linkLang.langCode,
 										id : 'advLangCode',
 										width : '110px',
@@ -1045,5 +1047,5 @@
 									{
 										type : 'text',
-										label : editor.lang.link.tabIndex,
+										label : linkLang.tabIndex,
 										id : 'advTabIndex',
 										width : '80px',
@@ -1069,5 +1071,5 @@
 									{
 										type : 'text',
-										label : editor.lang.link.advisoryTitle,
+										label : linkLang.advisoryTitle,
 										'default' : '',
 										id : 'advTitle',
@@ -1078,5 +1080,5 @@
 									{
 										type : 'text',
-										label : editor.lang.link.advisoryContentType,
+										label : linkLang.advisoryContentType,
 										'default' : '',
 										id : 'advContentType',
@@ -1094,5 +1096,5 @@
 									{
 										type : 'text',
-										label : editor.lang.link.cssClasses,
+										label : linkLang.cssClasses,
 										'default' : '',
 										id : 'advCSSClasses',
@@ -1103,5 +1105,5 @@
 									{
 										type : 'text',
-										label : editor.lang.link.charset,
+										label : linkLang.charset,
 										'default' : '',
 										id : 'advCharset',
@@ -1118,5 +1120,5 @@
 									{
 										type : 'text',
-										label : editor.lang.link.styles,
+										label : linkLang.styles,
 										'default' : '',
 										id : 'advStyles',
@@ -1253,4 +1255,7 @@
 					onclickList.push( featureList.join( ',' ), '\'); return false;' );
 					attributes[ '_cke_pa_onclick' ] = onclickList.join( '' );
+
+					// Add the "target" attribute. (#5074)
+					removeAttributes.push( 'target' );
 				}
 				else
@@ -1384,5 +1389,5 @@
 			var linkType = this.getContentElement( 'info', 'linkType' ),
 					urlField;
-			if ( linkType && linkType.getValue( ) == 'url' )
+			if ( linkType && linkType.getValue() == 'url' )
 			{
 				urlField = this.getContentElement( 'info', 'url' );
Index: CKEditor/branches/versions/3.5.x/_source/plugins/link/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/link/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/link/plugin.js	(revision 6050)
@@ -177,8 +177,15 @@
 	getSelectedLink : function( editor )
 	{
-		var range;
 		try
 		{
-			range  = editor.getSelection().getRanges( true )[ 0 ];
+			var selection = editor.getSelection();
+			if ( selection.getType() == CKEDITOR.SELECTION_ELEMENT )
+			{
+				var selectedElement = selection.getSelectedElement();
+				if ( selectedElement.is( 'a' ) )
+					return selectedElement;
+			}
+
+			var range = selection.getRanges( true )[ 0 ];
 			range.shrink( CKEDITOR.SHRINK_TEXT );
 			var root = range.getCommonAncestor();
Index: CKEditor/branches/versions/3.5.x/_source/plugins/list/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/list/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/list/plugin.js	(revision 6050)
@@ -81,5 +81,5 @@
 				currentListItem = null,
 				paragraphName = ( paragraphMode == CKEDITOR.ENTER_P ? 'p' : 'div' );
-			while ( true )
+			while ( 1 )
 			{
 				var item = listArray[ currentIndex ];
@@ -88,10 +88,10 @@
 					if ( !rootNode || listArray[ currentIndex ].parent.getName() != rootNode.getName() )
 					{
-						rootNode = listArray[ currentIndex ].parent.clone( false, true );
+						rootNode = listArray[ currentIndex ].parent.clone( false, 1 );
 						retval.append( rootNode );
 					}
-					currentListItem = rootNode.append( item.element.clone( false, true ) );
+					currentListItem = rootNode.append( item.element.clone( 0, 1 ) );
 					for ( var i = 0 ; i < item.contents.length ; i++ )
-						currentListItem.append( item.contents[i].clone( true, true ) );
+						currentListItem.append( item.contents[i].clone( 1, 1 ) );
 					currentIndex++;
 				}
@@ -109,10 +109,17 @@
 					else
 					{
-						// Create completely new blocks here, attributes are dropped.
-						if ( dir || ( paragraphMode != CKEDITOR.ENTER_BR && item.grandparent.getName() != 'td' ) )
+						// Create completely new blocks here.
+						if ( dir || item.element.hasAttributes() ||
+							( paragraphMode != CKEDITOR.ENTER_BR && item.grandparent.getName() != 'td' ) )
 						{
 							currentListItem = doc.createElement( paragraphName );
-							if ( dir )
-								currentListItem.setAttribute( 'dir', dir );
+							item.element.copyAttributes( currentListItem, { type:1, value:1 } );
+							dir && currentListItem.setAttribute( 'dir', dir );
+
+							// There might be a case where there are no attributes in the element after all
+							// (i.e. when "type" or "value" are the only attributes set). In this case, if enterMode = BR,
+							// the current item should be a fragment.
+							if ( !dir && paragraphMode == CKEDITOR.ENTER_BR && !currentListItem.hasAttributes() )
+								currentListItem = new CKEDITOR.dom.documentFragment( doc );
 						}
 						else
@@ -121,5 +128,5 @@
 
 					for ( i = 0 ; i < item.contents.length ; i++ )
-						currentListItem.append( item.contents[i].clone( true, true ) );
+						currentListItem.append( item.contents[i].clone( 1, 1 ) );
 
 					if ( currentListItem.type == CKEDITOR.NODE_DOCUMENT_FRAGMENT
@@ -269,4 +276,9 @@
 			commonParent = commonParent.getCommonAncestor( contents[i].getParent() );
 
+		var useComputedState = editor.config.useComputedState,
+			listDir, explicitDirection;
+
+		useComputedState = useComputedState === undefined || useComputedState;
+
 		// We want to insert things that are in the same tree level only, so calculate the contents again
 		// by expanding the selected blocks to the same tree level.
@@ -280,4 +292,20 @@
 				{
 					listContents.push( contentNode );
+
+					// Determine the lists's direction.
+					if ( !explicitDirection && contentNode.getDirection() )
+						explicitDirection = 1;
+
+					var itemDir = contentNode.getDirection( useComputedState );
+
+					if ( listDir !== null )
+					{
+						// If at least one LI have a different direction than current listDir, we can't have listDir.
+						if ( listDir && listDir != itemDir )
+							listDir = null;
+						else
+							listDir = itemDir;
+					}
+
 					break;
 				}
@@ -291,23 +319,27 @@
 		// Insert the list to the DOM tree.
 		var insertAnchor = listContents[ listContents.length - 1 ].getNext(),
-			listNode = doc.createElement( this.type ),
-			dir;
+			listNode = doc.createElement( this.type );
 
 		listsCreated.push( listNode );
+
+		var contentBlock, listItem;
+
 		while ( listContents.length )
 		{
-			var contentBlock = listContents.shift(),
-				listItem = doc.createElement( 'li' );
-
-			// Preserve heading structure when converting to list item. (#5271)
-			if ( headerTagRegex.test( contentBlock.getName() ) )
+			contentBlock = listContents.shift();
+			listItem = doc.createElement( 'li' );
+
+			// Preserve preformat block and heading structure when converting to list item. (#5335) (#5271)
+			if ( contentBlock.is( 'pre' ) || headerTagRegex.test( contentBlock.getName() ) )
 				contentBlock.appendTo( listItem );
 			else
 			{
-				if ( contentBlock.hasAttribute( 'dir' ) )
-				{
-					dir = dir || contentBlock.getAttribute( 'dir' );
+				// Remove DIR attribute if it was merged into list root.
+				if ( listDir && contentBlock.getDirection() )
+				{
+					contentBlock.removeStyle( 'direction' );
 					contentBlock.removeAttribute( 'dir' );
 				}
+
 				contentBlock.copyAttributes( listItem );
 				contentBlock.moveChildren( listItem );
@@ -316,12 +348,9 @@
 
 			listItem.appendTo( listNode );
-
-			// Append a bogus BR to force the LI to render at full height
-			if ( !CKEDITOR.env.ie )
-				listItem.appendBogus();
-		}
-
-		if ( dir )
-			listNode.setAttribute( 'dir', dir );
+		}
+
+		// Apply list root dir only if it has been explicitly declared.
+		if ( listDir && explicitDirection )
+			listNode.setAttribute( 'dir', listDir );
 
 		if ( insertAnchor )
@@ -425,5 +454,5 @@
 							( editor.config.enterMode == CKEDITOR.ENTER_DIV ? 'div' : 'br' ) );
 					paragraph.appendTo( body );
-					ranges = [ new CKEDITOR.dom.range( doc ) ];
+					ranges = new CKEDITOR.dom.rangeList( [ new CKEDITOR.dom.range( doc ) ] );
 					// IE exception on inserting anything when anchor inside <br>.
 					if ( paragraph.is( 'br' ) )
@@ -444,7 +473,5 @@
 					if ( enclosedNode && enclosedNode.is
 						&& this.type == enclosedNode.getName() )
-					{
-						setState.call( this, editor, CKEDITOR.TRISTATE_ON );
-					}
+							setState.call( this, editor, CKEDITOR.TRISTATE_ON );
 				}
 			}
@@ -488,5 +515,5 @@
 						pathElementsCount = pathElements.length,
 						listNode = null,
-						processedFlag = false,
+						processedFlag = 0,
 						blockLimit = path.blockLimit,
 						element;
@@ -514,5 +541,5 @@
 								CKEDITOR.dom.element.setMarker( database, element, 'list_group_object', groupObj );
 							}
-							processedFlag = true;
+							processedFlag = 1;
 							break;
 						}
@@ -567,8 +594,8 @@
 						sibling.remove();
 						// Move children order by merge direction.(#3820)
-						sibling.moveChildren( listNode, rtl ? true : false );
+						sibling.moveChildren( listNode, rtl );
 					}
 				} )();
-				mergeSibling( true );
+				mergeSibling( 1 );
 			}
 
Index: CKEditor/branches/versions/3.5.x/_source/plugins/listblock/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/listblock/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/listblock/plugin.js	(revision 6050)
@@ -82,5 +82,5 @@
 					{
 						var pendingHtml = this._.pendingHtml,
-							id = 'cke_' + CKEDITOR.tools.getNextNumber();
+							id = CKEDITOR.tools.getNextId();
 
 						if ( !this._.started )
@@ -110,5 +110,5 @@
 						this._.close();
 
-						var id = 'cke_' + CKEDITOR.tools.getNextNumber();
+						var id = CKEDITOR.tools.getNextId();
 
 						this._.groups[ title ] = id;
Index: CKEditor/branches/versions/3.5.x/_source/plugins/liststyle/dialogs/liststyle.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/liststyle/dialogs/liststyle.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/liststyle/dialogs/liststyle.js	(revision 6050)
@@ -13,5 +13,5 @@
 
 		range.shrink( CKEDITOR.SHRINK_TEXT );
-		return range.getCommonAncestor().getAscendant( listTag, true );
+		return range.getCommonAncestor().getAscendant( listTag, 1 );
 	}
 
@@ -29,8 +29,9 @@
 	function listStyle( editor, startupPage )
 	{
+		var lang = editor.lang.list;
 		if ( startupPage == 'bulletedListStyle' )
 		{
 			return {
-				title : editor.lang.list.bulletedTitle,
+				title : lang.bulletedTitle,
 				minWidth : 300,
 				minHeight : 50,
@@ -44,13 +45,13 @@
 							{
 								type : 'select',
-								label : editor.lang.list.type,
+								label : lang.type,
 								id : 'type',
 								style : 'width: 150px; margin: auto;',
 								items :
 								[
-									[ editor.lang.list.notset, '' ],
-									[ editor.lang.list.circle, 'circle' ],
-									[ editor.lang.list.disc,  'disc' ],
-									[ editor.lang.list.square, 'square' ]
+									[ lang.notset, '' ],
+									[ lang.circle, 'circle' ],
+									[ lang.disc,  'disc' ],
+									[ lang.square, 'square' ]
 								],
 								setup : function( element )
@@ -96,10 +97,10 @@
 			var listStyleOptions =
 			[
-				[ editor.lang.list.notset, '' ],
-				[ editor.lang.list.lowerRoman, 'lower-roman' ],
-				[ editor.lang.list.upperRoman, 'upper-roman' ],
-				[ editor.lang.list.lowerAlpha, 'lower-alpha' ],
-				[ editor.lang.list.upperAlpha, 'upper-alpha' ],
-				[ editor.lang.list.decimal, 'decimal' ]
+				[ lang.notset, '' ],
+				[ lang.lowerRoman, 'lower-roman' ],
+				[ lang.upperRoman, 'upper-roman' ],
+				[ lang.lowerAlpha, 'lower-alpha' ],
+				[ lang.upperAlpha, 'upper-alpha' ],
+				[ lang.decimal, 'decimal' ]
 			];
 
@@ -107,13 +108,13 @@
 			{
 				listStyleOptions.concat( [
-					[ editor.lang.list.armenian, 'armenian' ],
-					[ editor.lang.list.decimalLeadingZero, 'decimal-leading-zero' ],
-					[ editor.lang.list.georgian, 'georgian' ],
-					[ editor.lang.list.lowerGreek, 'lower-greek' ]
+					[ lang.armenian, 'armenian' ],
+					[ lang.decimalLeadingZero, 'decimal-leading-zero' ],
+					[ lang.georgian, 'georgian' ],
+					[ lang.lowerGreek, 'lower-greek' ]
 				]);
 			}
 
 			return {
-				title : editor.lang.list.numberedTitle,
+				title : lang.numberedTitle,
 				minWidth : 300,
 				minHeight : 50,
@@ -131,8 +132,8 @@
 								[
 									{
-										label : editor.lang.list.start,
+										label : lang.start,
 										type : 'text',
 										id : 'start',
-										validate : CKEDITOR.dialog.validate.integer( editor.lang.list.validateStartNumber ),
+										validate : CKEDITOR.dialog.validate.integer( lang.validateStartNumber ),
 										setup : function( element )
 										{
@@ -147,5 +148,5 @@
 									{
 										type : 'select',
-										label : editor.lang.list.type,
+										label : lang.type,
 										id : 'type',
 										style : 'width: 100%;',
Index: CKEditor/branches/versions/3.5.x/_source/plugins/maximize/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/maximize/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/maximize/plugin.js	(revision 6050)
@@ -11,6 +11,6 @@
 			return [];
 
-		var hijackRecord = [];
-		var hijackNames = [ 'style', 'className' ];
+		var hijackRecord = [],
+			hijackNames = [ 'style', 'className' ];
 		for ( var i = 0 ; i < hijackNames.length ; i++ )
 		{
@@ -130,10 +130,10 @@
 		{
 			var lang = editor.lang;
-			var mainDocument = CKEDITOR.document;
-			var mainWindow = mainDocument.getWindow();
+			var mainDocument = CKEDITOR.document,
+				mainWindow = mainDocument.getWindow();
 
 			// Saved selection and scroll position for the editing area.
-			var savedSelection;
-			var savedScroll;
+			var savedSelection,
+				savedScroll;
 
 			// Saved scroll position for the outer window.
@@ -195,4 +195,12 @@
 
 							// Hide scroll bars.
+							var viewPaneSize = mainWindow.getViewPaneSize();
+							var styles =
+								{
+									overflow : 'hidden',
+									width : ( CKEDITOR.env.opera ? viewPaneSize.width : 0 ) + 'px',
+									height : ( CKEDITOR.env.opera ? viewPaneSize.height - 16 : 0 ) + 'px'
+								};
+
 							if ( CKEDITOR.env.ie )
 							{
@@ -202,11 +210,10 @@
 							else
 							{
-								mainDocument.getBody().setStyles(
-									{
-										overflow : 'hidden',
-										width : '0px',
-										height : '0px'
-									} );
-							}
+								mainDocument.getBody().setStyles( styles );
+							}
+
+							// #4023: [Opera] Maximize plugin
+							if ( CKEDITOR.env.opera )
+								mainDocument.getBody().getParent().setStyles( styles );
 
 							// Scroll to the top left (IE needs some time for it - #4923).
@@ -216,5 +223,4 @@
 
 							// Resize and move to top left.
-							var viewPaneSize = mainWindow.getViewPaneSize();
 							container.setStyle( 'position', 'absolute' );
 							container.$.offsetLeft;			// SAFARI BUG: See #2066.
@@ -334,8 +340,9 @@
 				} );
 
-			// Restore the command state after mode change.
+			// Restore the command state after mode change, unless it has been changed to disabled (#6467)
 			editor.on( 'mode', function()
 				{
-					editor.getCommand( 'maximize' ).setState( savedState );
+					var command = editor.getCommand( 'maximize' );
+					command.setState( command.state == CKEDITOR.TRISTATE_DISABLED ? CKEDITOR.TRISTATE_DISABLED : savedState );
 				}, null, null, 100 );
 		}
Index: CKEditor/branches/versions/3.5.x/_source/plugins/menu/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/menu/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/menu/plugin.js	(revision 6050)
@@ -279,7 +279,7 @@
 						{
 							clearTimeout( this._.showSubTimeout );
-							this._.showSubTimeout = CKEDITOR.tools.setTimeout( this._.showSubMenu, editor.config.menu_subMenuDelay, this, [ index ] );
+							this._.showSubTimeout = CKEDITOR.tools.setTimeout( this._.showSubMenu, editor.config.menu_subMenuDelay || 400, this, [ index ] );
 						},
-						this);
+						this );
 
 					this._.itemOutFn = CKEDITOR.tools.addFunction( function( index )
@@ -287,5 +287,5 @@
 							clearTimeout( this._.showSubTimeout );
 						},
-						this);
+						this );
 
 					this._.itemClickFn = CKEDITOR.tools.addFunction( function( index )
@@ -304,5 +304,5 @@
 								this._.onClick( item );
 						},
-						this);
+						this );
 				}
 
@@ -310,6 +310,6 @@
 				sortItems( items );
 
-				var chromeRoot = editor.container.getChild( 1 );
-				var mixedContentClass = chromeRoot.hasClass( 'cke_mixed_dir_content' ) ? ' cke_mixed_dir_content' : '';
+				var chromeRoot = editor.container.getChild( 1 ),
+					mixedContentClass = chromeRoot.hasClass( 'cke_mixed_dir_content' ) ? ' cke_mixed_dir_content' : '';
 
 				// Build the HTML that composes the menu and its items.
@@ -486,5 +486,4 @@
  * config.menu_subMenuDelay = 0;
  */
-CKEDITOR.config.menu_subMenuDelay = 400;
 
 /**
Index: CKEditor/branches/versions/3.5.x/_source/plugins/newpage/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/newpage/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/newpage/plugin.js	(revision 6050)
@@ -20,5 +20,5 @@
 				{
 					var command = this;
-					editor.setData( editor.config.newpage_html, function()
+					editor.setData( editor.config.newpage_html || '', function()
 					{
 						// Save the undo snapshot after all document changes are affected. (#4889)
@@ -52,3 +52,2 @@
  * config.newpage_html = '&lt;p&gt;Type your text here.&lt;/p&gt;';
  */
-CKEDITOR.config.newpage_html = '';
Index: CKEditor/branches/versions/3.5.x/_source/plugins/pagebreak/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/pagebreak/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/pagebreak/plugin.js	(revision 6050)
@@ -63,5 +63,11 @@
 
 							if ( childStyle && ( /page-break-after\s*:\s*always/i ).test( style ) && ( /display\s*:\s*none/i ).test( childStyle ) )
-								return editor.createFakeParserElement( element, 'cke_pagebreak', 'div' );
+							{
+								var fakeImg = editor.createFakeParserElement( element, 'cke_pagebreak', 'div' );
+								var label = editor.lang.pagebreakAlt;
+								fakeImg.attributes[ 'alt' ] = label;
+								fakeImg.attributes[ 'aria-label' ] = label;
+								return fakeImg;
+							}
 						}
 					}
@@ -78,8 +84,11 @@
 	{
 		// Create the element that represents a print break.
+		var label = editor.lang.pagebreakAlt;
 		var breakObject = CKEDITOR.dom.element.createFromHtml( '<div style="page-break-after: always;"><span style="display: none;">&nbsp;</span></div>' );
 
 		// Creates the fake image used for this element.
 		breakObject = editor.createFakeElement( breakObject, 'cke_pagebreak', 'div' );
+		breakObject.setAttribute( 'alt', label );
+		breakObject.setAttribute( 'aria-label', label );
 
 		var ranges = editor.getSelection().getRanges( true );
@@ -104,5 +113,5 @@
 			var previous = breakObject.getPrevious();
 
-			if ( CKEDITOR.dtd[ previous.getName() ].div )
+			if ( previous && CKEDITOR.dtd[ previous.getName() ].div )
 				breakObject.move( previous );
 		}
